#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define WIDTH 352
#define HEIGHT 240

void scramble_board(char *player_board)
{
int zerox,zeroy,zero_ptr;
int t,x,r;

  srand(time(NULL));
  for (t=0; t<25; t++) player_board[t]=t+'a';
  player_board[t]=0;

  zerox=0;
  zeroy=0;
  zero_ptr=0;

  for (t=0; t<1000; t++)
  {
    x=rand()%4;
    if (x<0) x=-x;

    while(1)
    {
      if (x==0 && zeroy!=0) break;  /* up */
      if (x==1 && zerox!=4) break;  /* right */
      if (x==2 && zeroy!=4) break;  /* down */
      if (x==3 && zerox!=0) break;  /* left */
      x++;
      if (x>3) x=0;
    }

    if (x==0)
    {
      x=(rand()%zeroy)+1;
      if (x<0) x=-x;

      for (r=0; r<x; r++)
      {
        player_board[zero_ptr]=player_board[zero_ptr-5];
        zero_ptr=zero_ptr-5;
        player_board[zero_ptr]='a';
        zeroy--;
      }
    }
      else
    if (x==1)
    {
      x=(rand()%(4-zerox))+1;
      if (x<0) x=-x;

      for (r=0; r<x; r++)
      {
        player_board[zero_ptr]=player_board[zero_ptr+1];
        zero_ptr++;
        player_board[zero_ptr]='a';
        zerox++;
      }
    }
      else
    if (x==2)
    {
      x=(rand()%(4-zeroy))+1;
      if (x<0) x=-x;

      for (r=0; r<x; r++)
      {
        player_board[zero_ptr]=player_board[zero_ptr+5];
        zero_ptr=zero_ptr+5;
        player_board[zero_ptr]='a';
        zeroy++;
      }
    }
      else
    if (x==3)
    {
      x=(rand()%zerox)+1;
      if (x<0) x=-x;

      for (r=0; r<x; r++)
      {
        player_board[zero_ptr]=player_board[zero_ptr-1];
        zero_ptr--;
        player_board[zero_ptr]='a';
        zerox--;
      }
    }
  }
}

int main(int argc, char *argv[])
{
char *querystring;
char player_board[26];
int t,cursorx,cursory;

  printf("Content-Type: text/html\r\n\r\n");

  querystring=getenv("QUERY_STRING");

  if (querystring==0 || querystring[0]==0)
  {
    scramble_board(player_board);
  }
    else
  {
    player_board[0]=0;

    for (t=0; t<25; t++) player_board[t]=querystring[t];
    player_board[t]=0;

    t++;
    cursorx=0; cursory=0;

    while(1)
    {
      if (querystring[t]==0) break;
      if (querystring[t]==',')
      {
        querystring[t]=0;
        cursorx=atoi(querystring+26)/(WIDTH/5);
        cursory=atoi(querystring+t+1)/(HEIGHT/5);

        if (cursorx<4 && player_board[cursorx+1+cursory*5]=='a')
        {
          player_board[cursorx+1+cursory*5]=player_board[cursorx+cursory*5];
          player_board[cursorx+cursory*5]='a';
        }
          else
        if (cursorx>0 && player_board[cursorx-1+cursory*5]=='a')
        {
          player_board[cursorx-1+cursory*5]=player_board[cursorx+cursory*5];
          player_board[cursorx+cursory*5]='a';
        }
          else
        if (cursory<4 && player_board[cursorx+(cursory+1)*5]=='a')
        {
          player_board[cursorx+(cursory+1)*5]=player_board[cursorx+cursory*5];
          player_board[cursorx+cursory*5]='a';
        }
          else
        if (cursory>0 && player_board[cursorx+(cursory-1)*5]=='a')
        {
          player_board[cursorx+(cursory-1)*5]=player_board[cursorx+cursory*5];
          player_board[cursorx+cursory*5]='a';
        }

        break; 
      }

      t++;
    }
  }


  printf("<html><body><table width=100%% height=100%%>\n"
         "<tr><td valign='middle' align='center'>\n"
         "<b>Michael Kohn's Jumble Puzzle</b><br><br>\n"
         "<a href='jumble.cgi?%s'>"
         "<img src='jumblepic.cgi?%s' ISMAP border=0>\n"
         "</a>"
         "</td></tr></table>\n"
         "</body></html>\n\n",player_board,player_board);

  return 0;
}

